%undefine _package_note_flags

Name:           ocaml-qcheck
Version:        0.18.1
Release:        1%{?dist}
Summary:        QuickCheck inspired property-based testing for OCaml

License:        BSD
URL:            https://c-cube.github.io/qcheck/
Source0:        https://github.com/c-cube/qcheck/archive/v%{version}/%{name}-%{version}.tar.gz

BuildRequires:  ocaml >= 4.08.0
BuildRequires:  ocaml-dune
BuildRequires:  ocaml-odoc
BuildRequires:  ocaml-alcotest-devel
BuildRequires:  ocaml-ounit-devel

Requires:       %{name}-ounit = %{version}-%{release}

%global _desc %{expand:
Qcheck enables checking invariants (properties of a type) over randomly
generated instances of the type.  It provides combinators for generating
instances and printing them.}

%description %_desc

This package is a compatibility wrapper for qcheck.  New code should
use either ocaml-qcheck-alcotest or ocaml-qcheck-ounit.


%package        devel
Summary:        Development files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}
Requires:       %{name}-ounit-devel%{?_isa} = %{version}-%{release}


%description    devel %_desc

The %{name}-devel package contains libraries and signature files
for developing applications that use the qcheck compatibility wrapper.
New code should instead use %{name}-alcotest-devel or
%{name}-ounit-devel.


%package        core
Summary:        QuickCheck inspired property-based testing for OCaml


%description    core %_desc
This package provides alcotest support for qcheck.


%package        core-devel
Summary:        Development files for %{name}-core
Requires:       %{name}-core%{?_isa} = %{version}-%{release}


%description    core-devel %_desc

The %{name}-core-devel package contains libraries and signature
files for developing applications that use %{name}-core.


%package        ounit
Summary:        OUnit support for %{name}
Requires:       %{name}-core%{?_isa} = %{version}-%{release}


%description    ounit %_desc

This package provides ounit support for qcheck.


%package        ounit-devel
Summary:        Development files for %{name}-ounit
Requires:       %{name}-ounit%{?_isa} = %{version}-%{release}
Requires:       %{name}-core-devel%{?_isa} = %{version}-%{release}


%description    ounit-devel %_desc

The %{name}-ounit-devel package contains libraries and signature
files for developing applications that use %{name}-ounit.


%package        alcotest
Summary:        Alcotest support for %{name}
Requires:       %{name}-core%{?_isa} = %{version}-%{release}


%description    alcotest %_desc

This package provides alcotest support for qcheck.


%package        alcotest-devel
Summary:        Development files for %{name}-alcotest
Requires:       %{name}-alcotest%{?_isa} = %{version}-%{release}
Requires:       %{name}-core-devel%{?_isa} = %{version}-%{release}


%description    alcotest-devel %_desc

The %{name}-alcotest-devel package contains libraries and signature
files for developing applications that use %{name}-alcotest.


%package        doc
Summary:        Documentation for %{name}
BuildArch:      noarch


%description    doc
Documentation for %{name}.


%prep
%autosetup -n qcheck-%{version} -p1


%build
dune build %{?_smp_mflags} --verbose --release @install
dune build %{?_smp_mflags} @doc


%install
dune install --destdir=%{buildroot}

# We do not want the dune markers
find _build/default/_doc/_html -name .dune-keep -delete

# These files will be installed using doc and license directives.
rm -r %{buildroot}%{_prefix}/doc


# Tests do not pass on 32-bit due to taking fewer shrink steps than expected
%ifnarch %{ix86} %{arm}
%check
# ppc64le, at least, needs extra stack space to avoid a segfault
ulimit -s unlimited
dune runtest --no-buffer --release
%endif


%files
%doc README.adoc CHANGELOG.md
%license LICENSE
%dir %{_libdir}/ocaml/qcheck/
%{_libdir}/ocaml/qcheck/META
%{_libdir}/ocaml/qcheck/*.cma
%{_libdir}/ocaml/qcheck/*.cmi
%ifarch %{ocaml_native_compiler}
%{_libdir}/ocaml/qcheck/*.cmxs
%endif


%files devel
%doc README.adoc CHANGELOG.md
%license LICENSE
%ifarch %{ocaml_native_compiler}
%{_libdir}/ocaml/qcheck/*.a
%{_libdir}/ocaml/qcheck/*.cmxa
%{_libdir}/ocaml/qcheck/*.cmx
%endif
%{_libdir}/ocaml/qcheck/*.ml
%{_libdir}/ocaml/qcheck/*.cma
%{_libdir}/ocaml/qcheck/*.cmi
%{_libdir}/ocaml/qcheck/*.cmt
%{_libdir}/ocaml/qcheck/dune-package
%{_libdir}/ocaml/qcheck/opam


%files core
%dir %{_libdir}/ocaml/qcheck-core/
%dir %{_libdir}/ocaml/qcheck-core/runner/
%{_libdir}/ocaml/qcheck-core/META
%{_libdir}/ocaml/qcheck-core/{*/,}*.cma
%{_libdir}/ocaml/qcheck-core/{*/,}*.cmi
%ifarch %{ocaml_native_compiler}
%{_libdir}/ocaml/qcheck-core/{*/,}*.cmxs
%endif


%files core-devel
%ifarch %{ocaml_native_compiler}
%{_libdir}/ocaml/qcheck-core/{*/,}*.a
%{_libdir}/ocaml/qcheck-core/{*/,}*.cmxa
%{_libdir}/ocaml/qcheck-core/{*/,}*.cmx
%endif
%{_libdir}/ocaml/qcheck-core/{*/,}*.ml
%{_libdir}/ocaml/qcheck-core/{*/,}*.mli
%{_libdir}/ocaml/qcheck-core/{*/,}*.cma
%{_libdir}/ocaml/qcheck-core/{*/,}*.cmi
%{_libdir}/ocaml/qcheck-core/{*/,}*.cmt
%{_libdir}/ocaml/qcheck-core/{*/,}*.cmti
%{_libdir}/ocaml/qcheck-core/dune-package
%{_libdir}/ocaml/qcheck-core/opam


%files ounit
%dir %{_libdir}/ocaml/qcheck-ounit/
%{_libdir}/ocaml/qcheck-ounit/META
%{_libdir}/ocaml/qcheck-ounit/*.cma
%{_libdir}/ocaml/qcheck-ounit/*.cmi
%ifarch %{ocaml_native_compiler}
%{_libdir}/ocaml/qcheck-ounit/*.cmxs
%endif


%files ounit-devel
%ifarch %{ocaml_native_compiler}
%{_libdir}/ocaml/qcheck-ounit/*.a
%{_libdir}/ocaml/qcheck-ounit/*.cmxa
%{_libdir}/ocaml/qcheck-ounit/*.cmx
%endif
%{_libdir}/ocaml/qcheck-ounit/*.ml
%{_libdir}/ocaml/qcheck-ounit/*.mli
%{_libdir}/ocaml/qcheck-ounit/*.cma
%{_libdir}/ocaml/qcheck-ounit/*.cmi
%{_libdir}/ocaml/qcheck-ounit/*.cmt
%{_libdir}/ocaml/qcheck-ounit/*.cmti
%{_libdir}/ocaml/qcheck-ounit/dune-package
%{_libdir}/ocaml/qcheck-ounit/opam


%files alcotest
%dir %{_libdir}/ocaml/qcheck-alcotest/
%{_libdir}/ocaml/qcheck-alcotest/META
%{_libdir}/ocaml/qcheck-alcotest/*.cma
%{_libdir}/ocaml/qcheck-alcotest/*.cmi
%ifarch %{ocaml_native_compiler}
%{_libdir}/ocaml/qcheck-alcotest/*.cmxs
%endif


%files alcotest-devel
%ifarch %{ocaml_native_compiler}
%{_libdir}/ocaml/qcheck-alcotest/*.a
%{_libdir}/ocaml/qcheck-alcotest/*.cmxa
%{_libdir}/ocaml/qcheck-alcotest/*.cmx
%endif
%{_libdir}/ocaml/qcheck-alcotest/*.ml
%{_libdir}/ocaml/qcheck-alcotest/*.mli
%{_libdir}/ocaml/qcheck-alcotest/*.cma
%{_libdir}/ocaml/qcheck-alcotest/*.cmi
%{_libdir}/ocaml/qcheck-alcotest/*.cmt
%{_libdir}/ocaml/qcheck-alcotest/*.cmti
%{_libdir}/ocaml/qcheck-alcotest/dune-package
%{_libdir}/ocaml/qcheck-alcotest/opam


%files doc
%doc _build/default/_doc/_html/
%doc _build/default/_doc/_mlds/
%doc _build/default/_doc/_odoc/
%license LICENSE


%changelog
* Mon Feb 28 2022 Jerry James <loganjerry@gmail.com> - 0.18.1-1
- Version 0.18.1
- Disable tests on 32-bit x86
- Give ppc64le extra stack space for running tests

* Fri Feb 04 2022 Richard W.M. Jones <rjones@redhat.com> - 0.18-6
- OCaml 4.13.1 rebuild to remove package notes

* Thu Jan 20 2022 Fedora Release Engineering <releng@fedoraproject.org> - 0.18-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Tue Oct 12 2021 Jerry James <loganjerry@gmail.com> - 0.18-4
- Rebuild for alcotest 1.5.0
- Split into subpackages to manage dependencies

* Tue Oct 05 2021 Richard W.M. Jones <rjones@redhat.com> - 0.18-3
- OCaml 4.13.1 build

* Thu Jul 22 2021 Fedora Release Engineering <releng@fedoraproject.org> - 0.18-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Mon Jul 19 2021 Jerry James <loganjerry@gmail.com> - 0.18-1
- Move META to the main package

* Fri Jun 25 2021 Jerry James <loganjerry@gmail.com> - 0.18-1
- Version 0.18

* Wed Apr 14 2021 Jerry James <loganjerry@gmail.com> - 0.17-4
- Rebuild for alcotest 1.4.0

* Mon Mar  1 23:22:40 GMT 2021 Richard W.M. Jones <rjones@redhat.com> - 0.17-3
- OCaml 4.12.0 build

* Sat Feb 20 2021 Jerry James <loganjerry@gmail.com> - 0.17-2
- Rebuild for alcotest 1.3.0

* Tue Feb 16 2021 Jerry James <loganjerry@gmail.com> - 0.17-1
- Version 0.17
- Drop upstream patches

* Tue Feb  2 2021 Jerry James <loganjerry@gmail.com> - 0.16-4
- Bump and rebuild for updated ocaml-alcotest dep

* Tue Jan 26 2021 Fedora Release Engineering <releng@fedoraproject.org> - 0.16-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Wed Dec  2 2020 Jerry James <loganjerry@gmail.com> - 0.16-2
- Add upstream patches to fix numeric range issues

* Thu Nov  5 2020 Jerry James <loganjerry@gmail.com> - 0.16-1
- Version 0.16

* Fri Sep 25 2020 Jerry James <loganjerry@gmail.com> - 0.15-1
- Version 0.15

* Tue Sep 01 2020 Richard W.M. Jones <rjones@redhat.com> - 0.14-4
- OCaml 4.11.1 rebuild

* Fri Aug 28 2020 Jerry James <loganjerry@gmail.com> - 0.14-3
- Rebuild for alcotest 1.2.2

* Fri Aug 21 2020 Richard W.M. Jones <rjones@redhat.com> - 0.14-2
- OCaml 4.11.0 rebuild

* Wed Aug  5 2020 Jerry James <loganjerry@gmail.com> - 0.14-1
- Version 0.14

* Sat Aug 01 2020 Fedora Release Engineering <releng@fedoraproject.org> - 0.13-8
- Second attempt - Rebuilt for
  https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Tue Jul 28 2020 Fedora Release Engineering <releng@fedoraproject.org> - 0.13-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Tue May 05 2020 Richard W.M. Jones <rjones@redhat.com> - 0.13-6
- OCaml 4.11.0+dev2-2020-04-22 rebuild

* Wed Apr 22 2020 Richard W.M. Jones <rjones@redhat.com> - 0.13-5
- OCaml 4.11.0 pre-release attempt 2

* Sat Apr 04 2020 Richard W.M. Jones <rjones@redhat.com> - 0.13-4
- Bump release and rebuild.

* Sat Apr 04 2020 Richard W.M. Jones <rjones@redhat.com> - 0.13-3
- Update all OCaml dependencies for RPM 4.16.

* Wed Feb 26 2020 Richard W.M. Jones <rjones@redhat.com> - 0.13-2
- OCaml 4.10.0 final.

* Wed Feb 19 2020 Jerry James <loganjerry@gmail.com> - 0.13-1
- New upstream release.
- Build with alcotest support.
- Build documentation with odoc, and ship it in a new doc subpackage.

* Wed Jan 29 2020 Fedora Release Engineering <releng@fedoraproject.org> - 0.12-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_32_Mass_Rebuild

* Sun Jan 19 2020 Richard W.M. Jones <rjones@redhat.com> - 0.12-2
- OCaml 4.10.0+beta1 rebuild.

* Wed Dec 18 2019 Andy Li <andy@onthewings.net> - 0.12-1
- New upstream release. (RHBZ#1757625)
- Remove unneeded BuildRequires on opam-installer.

* Fri Aug 16 2019 Richard W.M. Jones <rjones@redhat.com> - 0.10-3
- OCaml 4.08.1 (final) rebuild.

* Thu Aug 01 2019 Richard W.M. Jones <rjones@redhat.com> - 0.10-2
- OCaml 4.08.1 (rc2) rebuild.

* Sat Jul 27 2019 Andy Li <andy@onthewings.net> - 0.10-1
- New upstream release.
- Update build system and commands from jbuilder to dune.

* Thu Jul 25 2019 Fedora Release Engineering <releng@fedoraproject.org> - 0.8-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Fri Feb 01 2019 Fedora Release Engineering <releng@fedoraproject.org> - 0.8-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Fri Jul 13 2018 Fedora Release Engineering <releng@fedoraproject.org> - 0.8-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Wed Jul 11 2018 Richard W.M. Jones <rjones@redhat.com> - 0.8-5
- OCaml 4.07.0 (final) rebuild.

* Wed Jun 20 2018 Richard W.M. Jones <rjones@redhat.com> - 0.8-4
- OCaml 4.07.0-rc1 rebuild.

* Mon May 14 2018 Andy Li <andy@onthewings.net> - 0.8-3
- Rebuilt against ounit.

* Thu Feb 08 2018 Fedora Release Engineering <releng@fedoraproject.org> - 0.8-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Mon Feb 05 2018 Andy Li <andy@onthewings.net> - 0.8-1
- New upstream release. (RHBZ#1541681)
- Enable debug package.

* Sat Dec 02 2017 Richard W.M. Jones <rjones@redhat.com> - 0.7-2
- OCaml 4.06.0 rebuild.

* Mon Nov 20 2017 Andy Li <andy@onthewings.net> - 0.7-1
- Initial RPM release.
